#!/usr/bin/env bash
#
# Prueba validacion de instalacion de java y de conexion ssl al servidor

echo "Ingrese url del servidor sin 'https://' por ejemplo para Google => google.com"
# read URL_BASE
read -p "Enter host: " URL_BASE

if [[ -z "$URL_BASE" ]]; then
    echo "[Error] Debe ingresar una URL" 1>&2
    exit 1
fi

if [ ! -d "$JAVA_HOME" ]
then
      echo "La variable JAVA_HOME no es un directorio valido"
      exit;
fi

echo "======= validando version java"
if type -p java; then
    _java=java
elif [[ -n "$JAVA_HOME" ]] && [[ -x "$JAVA_HOME/bin/java" ]];  then
    _java="$JAVA_HOME/bin/java"
else
    echo "[ERROR] No se pudo encontrar java. Puede descargar desde https://www.oracle.com/java/technologies/javase/javase8-archive-downloads.html"
    exit;
fi


if [[ "$_java" ]]; then
    version=$("$_java" -version 2>&1 | awk -F '"' '/version/ {print $2}')
    if [[ "$version" == "1.8.0_202" ]]; then
        echo "[OK] Java Version 1.8.0_202"
    else         
        echo "[WARNING] Se recomienda Java Version 1.8.0_202. Puede descargarla de https://www.oracle.com/java/technologies/javase/javase8-archive-downloads.html"
        echo "[INFO] Version instalada: ${version}"
    fi
fi

printf "\n"
echo "======= java version command"
"$_java" -version

printf "\n"
echo "======= java SSLPoke ${URL_BASE} 443"
RESULTPOKE=$("$_java" SSLPoke ${URL_BASE} 443)

if [ "$RESULTPOKE" != "Successfully connected" ]; then
    echo "[ERROR] Posiblemente el certificado SSL del servidor ${URL_BASE} tenga errores. Verifique!"
else
    echo "[OK] Java puede conectarse al servidor indicado por ssl"
fi